<?php
class DHVC_Woo_Page_Shortcode {

	protected $shop_single;
	protected $shop_thumbnails_size;
	protected $shortcodes;
	public function __construct() {
		$this->shortcodes = array(
			'dhvc_woo_product_page_images'								=>'dhvc_woo_product_page_images_shortcode',
			'dhvc_woo_product_page_title'								=>'dhvc_woo_product_page_title_shortcode',
			'dhvc_woo_product_page_rating'								=>'dhvc_woo_product_page_rating_shortcode',
			'dhvc_woo_product_page_price'								=>'dhvc_woo_product_page_price_shortcode',
			'dhvc_woo_product_page_excerpt'								=>'dhvc_woo_product_page_excerpt_shortcode',
			'dhvc_woo_product_page_description'							=>'dhvc_woo_product_page_description_shortcode',
			'dhvc_woo_product_page_additional_information'				=>'dhvc_woo_product_page_additional_information',
			'dhvc_woo_product_page_add_to_cart'							=>'dhvc_woo_product_page_add_to_cart_shortcode',
			'dhvc_woo_product_page_meta'								=>'dhvc_woo_product_page_meta_shortcode',
			'dhvc_woo_product_page_sharing'								=>'dhvc_woo_product_page_sharing_shortcode',
			'dhvc_woo_product_page_data_tabs'							=>'dhvc_woo_product_page_data_tabs_shortcode',
			'dhvc_woo_product_page_reviews'								=>'dhvc_woo_product_page_reviews_shortcode',
			'dhvc_woo_product_page_upsell'								=>'dhvc_woo_product_page_upsell_shortcode',
			'dhvc_woo_product_page_related_products'					=>'dhvc_woo_product_page_related_products_shortcode',
			'dhvc_woo_product_page_wishlist'							=>'dhvc_woo_product_page_wishlist_shortcode',
			'dhvc_woo_product_page_product_category'           			=> 'product_category',
			'dhvc_woo_product_page_product_categories'        			=> 'product_categories',
			'dhvc_woo_product_page_products'                   			=> 'products',
			'dhvc_woo_product_page_product_recent_products'            	=> 'recent_products',
			'dhvc_woo_product_page_product_sale_products'              	=> 'sale_products',
			'dhvc_woo_product_page_product_best_selling_products'      	=> 'best_selling_products',
			'dhvc_woo_product_page_product_top_rated_products'         	=> 'top_rated_products',
			'dhvc_woo_product_page_product_featured_products'          	=> 'featured_products',
			'dhvc_woo_product_page_product_attribute'          			=> 'product_attribute',
			'dhvc_woo_product_page_shop_messages'              			=> 'shop_messages',
			'dhvc_woo_product_page_order_tracking' 						=> 'order_tracking',
			'dhvc_woo_product_page_cart'           						=> 'cart',
			'dhvc_woo_product_page_checkout'      						=> 'checkout',
			'dhvc_woo_product_page_my_account'     						=> 'my_account',
			'dhvc_woo_product_custom_field'								=> 'dhvc_woo_product_custom_field_shortcode',
		);
		add_action( 'dhvc_woocommerce_page_before_override', array( &$this, 'add_shortcode' ));
	}
	
	public function add_shortcode(){
		global $post;
		if('product'==get_post_type($post)){
			foreach ( $this->shortcodes as $shortcode => $function ) {
				add_shortcode($shortcode , array(&$this,$function));
			}
			if (class_exists ( 'acf' )) {
				add_shortcode ( 'dhvc_woo_product_page_custom_field', array(&$this,'dhvc_woo_product_page_custom_field_shortcode') );
			}
			
			if(defined( 'YITH_YWZM_DIR' )){
				remove_shortcode('dhvc_woo_product_page_images');
				add_shortcode ( 'dhvc_woo_product_page_images',array(&$this,'dhvc_woo_product_page_images_shortcode_custom') );
			}
		}else{
			foreach ( $this->shortcodes as $shortcode => $function ) {
				add_shortcode($shortcode , array(&$this,'shortcode_error'));
			}
		}
	}
	
	public function shortcode_error($atts='',$content='',$tag=''){
		 return '<em style="color:red;display:block">Use shortcode "'.$tag.'" is wrong (Please view Product after assign Custom Template), to use plugin please see <a target="_blank" href="https://www.youtube.com/watch?v=DhqOQdR7K_8">Video</a><br><br></em>';
	}
	
	public function dhvc_woo_product_page_images_shortcode_custom($atts, $content = null){
		global $product;
		extract ( shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		if(function_exists('dhwcpl_single_product')){
			dhwcpl_single_product();
			dhwcpl_product_sale();
			dhwcpl_product_out_of_store();
		}
	
		$wc_get_template = function_exists( 'wc_get_template' ) ? 'wc_get_template' : 'woocommerce_get_template';
		$wc_get_template( 'single-product/product-image-magnifier.php', array(), '', YITH_YWZM_DIR . 'templates/' );
	
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	
	public function get_shortcodes(){
		return $this->shortcodes;
	}
	
	public function dhvc_woo_product_page_custom_field_shortcode($atts, $content = null) {
		extract ( shortcode_atts ( array (
			'field' => '',
			'el_class' => ''
		), $atts ) );
		if (empty ( $field )) {
			return '';
		}
		ob_start ();
		echo '<div class="dhvc_woo_product_page_custom_field ' . $el_class . '">';
		//the_field ( $field );
		$value = get_field($field);
		//filter to custom display
		$value = apply_filters('dhvc_woo_product_page_custom_field_value', $value, $field);
		if( is_array($value) )
		{
			$value = @implode(', ',$value);
		}
			
		echo do_shortcode($value);
			
		echo '</div>';
		return ob_get_clean ();
	}
	
	protected function resize( $attach_id = null, $img_url = null, $width, $height, $crop = false ) {
		// this is an attachment, so we have the ID
		if ( $attach_id ) {
			$image_src = wp_get_attachment_image_src( $attach_id, 'full' );
			$actual_file_path = get_attached_file( $attach_id );
			// this is not an attachment, let's use the image url
		} else if ( $img_url ) {
			$file_path = parse_url( $img_url );
			$actual_file_path = $_SERVER['DOCUMENT_ROOT'] . $file_path['path'];
			$actual_file_path = ltrim( $file_path['path'], '/' );
			$actual_file_path = rtrim( ABSPATH, '/' ).$file_path['path'];
			$orig_size = getimagesize( $actual_file_path );
			$image_src[0] = $img_url;
			$image_src[1] = $orig_size[0];
			$image_src[2] = $orig_size[1];
		}
		$file_info = pathinfo( $actual_file_path );
		$extension = '.'. $file_info['extension'];
		
		// the image path without the extension
		$no_ext_path = $file_info['dirname'].'/'.$file_info['filename'];
		
		$cropped_img_path = $no_ext_path.'-'.$width.'x'.$height.$extension;
		
		// checking if the file size is larger than the target size
		// if it is smaller or the same size, stop right here and return
		if ( $image_src[1] > $width || $image_src[2] > $height ) {
		
			// the file is larger, check if the resized version already exists (for $crop = true but will also work for $crop = false if the sizes match)
			if ( file_exists( $cropped_img_path ) ) {
				$cropped_img_url = str_replace( basename( $image_src[0] ), basename( $cropped_img_path ), $image_src[0] );
				$vt_image = array (
						'url' => $cropped_img_url,
						'width' => $width,
						'height' => $height
				);
				return $vt_image;
			}
		
			// $crop = false
			if ( $crop == false ) {
				// calculate the size proportionaly
				$proportional_size = wp_constrain_dimensions( $image_src[1], $image_src[2], $width, $height );
				$resized_img_path = $no_ext_path.'-'.$proportional_size[0].'x'.$proportional_size[1].$extension;
		
				// checking if the file already exists
				if ( file_exists( $resized_img_path ) ) {
					$resized_img_url = str_replace( basename( $image_src[0] ), basename( $resized_img_path ), $image_src[0] );
		
					$vt_image = array (
							'url' => $resized_img_url,
							'width' => $proportional_size[0],
							'height' => $proportional_size[1]
					);
					return $vt_image;
				}
			}
		
			// no cache files - let's finally resize it
			$img_editor =  wp_get_image_editor($actual_file_path);
		
			if ( is_wp_error($img_editor) || is_wp_error( $img_editor->resize($width, $height, $crop)) ) {
				return array (
						'url' => '',
						'width' => '',
						'height' => ''
				);
			}
		
			$new_img_path = $img_editor->generate_filename();
		
			if ( is_wp_error( $img_editor->save( $new_img_path ) ) ) {
				return array (
						'url' => '',
						'width' => '',
						'height' => ''
				);
			}
			if(!is_string($new_img_path)) {
				return array (
						'url' => '',
						'width' => '',
						'height' => ''
				);
			}
		
			$new_img_size = getimagesize( $new_img_path );
			$new_img = str_replace( basename( $image_src[0] ), basename( $new_img_path ), $image_src[0] );
		
			// resized output
			$vt_image = array (
					'url' => $new_img,
					'width' => $new_img_size[0],
					'height' => $new_img_size[1]
			);
			return $vt_image;
		}
		
		// default output - without resizing
		$vt_image = array (
				'url' => $image_src[0],
				'width' => $image_src[1],
				'height' => $image_src[2]
		);
		return $vt_image;
	}
	
	public function dhvc_woo_product_page_images_shortcode($atts, $content = null) {
		global $product;
		extract ( shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		if(function_exists('dhwcpl_single_product')){
			dhwcpl_single_product();
			dhwcpl_product_sale();
			dhwcpl_product_out_of_store();
		}
		if(class_exists('JCKWooThumbs')){
			$JCKWooThumbs = new JCKWooThumbs;
			$JCKWooThumbs->show_product_images();
		}else if(class_exists('WC_Product_Gallery_slider')){
			$enabled = get_option( 'woocommerce_product_gallery_slider_enabled' );
			$enabled_for_post   = get_post_meta( $post->ID, '_woocommerce_product_gallery_slider_enabled', true );
		
			if ( ( $enabled == 'yes' && $enabled_for_post !== 'no' ) || ( $enabled == 'no' && $enabled_for_post == 'yes' ) ) {
					WC_Product_Gallery_slider::setup_scripts_styles();
					WC_Product_Gallery_slider::show_product_gallery();
			}
		}else{
			woocommerce_show_product_sale_flash();
			woocommerce_show_product_images ();
		}
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	
	public function woocommerce_single_product_image_html($html,$post_id=null){
		global $product;
		$attachment_count = count( $product->get_gallery_attachment_ids() );
		if ( $attachment_count > 0 ) {
			$gallery = '[product-gallery]';
		} else {
			$gallery = '';
		}
		$image_title = esc_attr( get_the_title( get_post_thumbnail_id() ) );
		$image_link  = wp_get_attachment_url( get_post_thumbnail_id() );
		
		return sprintf( '<a href="%s" itemprop="image" class="woocommerce-main-image zoom" title="%s" data-rel="prettyPhoto' . $gallery . '"><img src="%s" /></a>', $image_link, $image_title, $this->shop_single['url'] );
	}
	
	public function woocommerce_single_product_image_thumbnail_html($html,$attachment_id, $post_id=null, $image_class=''){
		//var_dump(func_get_args());
		$image_title = esc_attr( get_the_title( $attachment_id ) );
		$image_link = wp_get_attachment_url( $attachment_id );
		$image = $this->resize($attachment_id, null,$this->shop_thumbnails_size['width'],$this->shop_thumbnails_size['height'],$this->shop_thumbnails_size['crop']);
		return sprintf( '<a href="%s" class="%s" title="%s" data-rel="prettyPhoto[product-gallery]"><img class="class="attachment-shop_thumbnail" src="%s" /></a>', $image_link, $image_class, $image_title, $image['url'] );
	}
	
	public function dhvc_woo_product_page_title_shortcode($atts, $content = null) {
		extract ( shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		
		if(function_exists('mk_woocommerce_enabled')){
			?>
			<h1 itemprop="name" class="single_product_title entry-title"><?php the_title(); ?></h1>
			<?php
		}else{
			woocommerce_template_single_title ();
		}
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	public function dhvc_woo_product_page_rating_shortcode($atts, $content = null) {
		global $post,$product;
		extract ( shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		if(function_exists('mk_woocommerce_enabled')){
			?>
			<?php
			$count   = $product->get_rating_count();
			$average = $product->get_average_rating();
		
			if ( $count > 0 ) : ?>
			
			<div class="woocommerce-product-rating" itemprop="aggregateRating" itemscope itemtype="http://schema.org/AggregateRating">
				<div class="star-rating" title="<?php printf( __( 'Rated %s out of 5', 'woocommerce' ), $average ); ?>">
					<span style="width:<?php echo ( ( $average / 5 ) * 100 ); ?>%">
						<strong itemprop="ratingValue" class="rating"><?php echo esc_html( $average ); ?></strong> <?php _e( 'out of 5', 'woocommerce' ); ?>
					</span>
				</div>
				<a href="#reviews" class="woocommerce-review-link" rel="nofollow">(<?php printf( _n( '%s customer review', '%s customer reviews', $count, 'woocommerce' ), '<span itemprop="ratingCount" class="count">' . $count . '</span>' ); ?>)</a>
			</div>
			<?php
			endif;
		}else{
			woocommerce_template_single_rating();
		}
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	public function dhvc_woo_product_page_price_shortcode($atts, $content = null) {
		global $post,$product;
		extract ( shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		if(function_exists('mk_woocommerce_enabled')){
			?>
			<div itemprop="offers" itemscope itemtype="http://schema.org/Offer">
	
				<div itemprop="price" class="mk-single-price"><?php echo $product->get_price_html(); ?></div>
	
				<meta itemprop="priceCurrency" content="<?php echo get_woocommerce_currency(); ?>" />
				<link itemprop="availability" href="http://schema.org/<?php echo $product->is_in_stock() ? 'InStock' : 'OutOfStock'; ?>" />
	
			</div>
			<?php
		}else{
			woocommerce_template_single_price ();
		}
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	public function dhvc_woo_product_page_excerpt_shortcode($atts, $content = null) {
		global $post,$product;
		extract ( shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		if(function_exists('mk_woocommerce_enabled')){
			?>
			<div itemprop="description">
				<?php echo apply_filters( 'woocommerce_short_description', $post->post_excerpt ) ?>
			</div>
			<?php
		}else{
			woocommerce_template_single_excerpt();
		}
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	
	public function dhvc_woo_product_page_description_shortcode($atts, $content = null){
		extract ( shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		
		the_content();
		
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	
	public function dhvc_woo_product_page_additional_information($atts, $content = null){
		global $product, $post;
		extract ( shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';

		if ( $product && ( $product->has_attributes() || ( $product->enable_dimensions_display() && ( $product->has_dimensions() || $product->has_weight() ) ) ) ) {
			wc_get_template( 'single-product/tabs/additional-information.php' );
		}

		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	
	public function dhvc_woo_product_page_add_to_cart_shortcode($atts, $content = null) {
		extract ( shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		woocommerce_template_single_add_to_cart ();
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	public function dhvc_woo_product_page_meta_shortcode($atts, $content = null) {
		global $post,$product;
		extract ( shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		
		if(function_exists('mk_woocommerce_enabled')){
			?>
			<div class="mk_product_meta">
	
				<?php do_action( 'woocommerce_product_meta_start' ); ?>
	
				<?php
				$cat_count = sizeof( get_the_terms( $post->ID, 'product_cat' ) );
				$tag_count = sizeof( get_the_terms( $post->ID, 'product_tag' ) );
	
				 if ( wc_product_sku_enabled() && ( $product->get_sku() || $product->is_type( 'variable' ) ) ) : ?>
	
					<span class="sku_wrapper"><?php _e( 'SKU:', 'woocommerce' ); ?> <span class="sku" itemprop="sku"><?php echo ( $sku = $product->get_sku() ) ? $sku : __( 'N/A', 'woocommerce' ); ?></span>.</span>
	
				<?php endif; ?>
	
				<?php echo $product->get_categories( ', ', '<span class="posted_in">' . _n( 'Category:', 'Categories:', $cat_count, 'woocommerce' ) . ' ', '.</span>' ); ?>
	
				<?php echo $product->get_tags( ', ', '<span class="tagged_as">' . _n( 'Tag:', 'Tags:', $tag_count, 'woocommerce' ) . ' ', '.</span>' ); ?>
	
				<?php do_action( 'woocommerce_product_meta_end' ); ?>
	
			</div>
			<?php
		}else{
			woocommerce_template_single_meta ();
		}
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	public function dhvc_woo_product_page_sharing_shortcode($atts, $content = null) {
		extract ( shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		if(function_exists('mk_woocommerce_enabled')){
			?>
			<ul class="woocommerce-social-share">
				<li><a class="facebook-share" data-title="<?php the_title();?>" data-url="<?php echo get_permalink(); ?>" href="#"><i class="mk-jupiter-icon-simple-facebook"></i></a></li>
				<li><a class="twitter-share" data-title="<?php the_title();?>" data-url="<?php echo get_permalink(); ?>" href="#"><i class="mk-moon-twitter"></i></a></li>
				<li><a class="googleplus-share" data-title="<?php the_title();?>" data-url="<?php echo get_permalink(); ?>" href="#"><i class="mk-jupiter-icon-simple-googleplus"></i></a></li>
				<li><a class="pinterest-share" data-image="<?php echo $image_src_array[0]; ?>" data-title="<?php echo get_the_title();?>" data-url="<?php echo get_permalink(); ?>" href="#"><i class="mk-jupiter-icon-simple-pinterest"></i></a></li>
			</ul>
			<?php
		}else{
			woocommerce_template_single_sharing ();
		}
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	public function dhvc_woo_product_page_data_tabs_shortcode($atts, $content = null) {
		extract ( shortcode_atts ( array (
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		woocommerce_output_product_data_tabs ();
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	public function dhvc_woo_product_page_reviews_shortcode($atts, $content = null){
		extract ( shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		if(comments_open() ){
			comments_template();
		}
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	public function dhvc_woo_product_page_related_products_shortcode($atts, $content = null) {
		extract ( shortcode_atts ( array (
				'posts_per_page'=>4,
				'columns'=>4,
				'orderby'=>'date',
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		echo woocommerce_related_products($atts);
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	
	public function dhvc_woo_product_custom_field_shortcode($atts, $content = null){
		global $post;
		extract ( shortcode_atts ( array (
			'key'=>'',
			'label'=>'',
			'el_class' => ''
		), $atts ) );

		$css_class = 'dhvc_woo_product-meta-field-' . $key
		. ( strlen( $el_class ) ? ' ' . $el_class : '' );
		if ( strlen( $label ) ) {
			$label_html = '<span class="dhvc_woo_product-meta-label">' . esc_html( $label ) . '</span>';
		}
		ob_start ();
		if ( !empty( $key ) && $value = get_post_meta($post->ID,$key,true) ) :  
		?>
			<div class="<?php echo esc_attr( $css_class ) ?>"><?php echo $label_html ?> <?php echo $value;?></div>
		<?php 
		endif;
		return ob_get_clean ();
	}
	
	public function dhvc_woo_product_page_upsell_shortcode($atts, $content = null) {
		extract ( shortcode_atts ( array (
				'posts_per_page'=>4,
				'columns'=>4,
				'orderby'=>'date',
				'el_class' => '' 
		), $atts ) );
		ob_start ();
		if (! empty ( $el_class ))
			echo '<div class="' . $el_class . '">';
		woocommerce_upsell_display ( $posts_per_page, $columns, $orderby);
		if (! empty ( $el_class ))
			echo '</div>';
		return ob_get_clean ();
	}
	
	public function dhvc_woo_product_page_wishlist_shortcode($atts, $content = null){
		extract ( shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		$output = '';
		$output .= '<div class="dhvc-woocommerce-page-wishlist ' . ($el_class ? $el_class :'') . '">';
		$output .= do_shortcode('[yith_wcwl_add_to_wishlist]');
		$output .= '</div>';
		return $output;
	}
	
	public function product_category($atts, $content = null) {
		extract ( shortcode_atts ( array (
			'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::product_category($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function product_categories($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::product_categories($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function products($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::products($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function recent_products($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::recent_products($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function sale_products($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::sale_products($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function best_selling_products($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::best_selling_products($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function top_rated_products($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::top_rated_products($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function featured_products($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::featured_products($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function product_attribute($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::product_attribute($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function shop_messages($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::shop_messages($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function order_tracking($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::order_tracking($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function cart($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::cart($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function checkout($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::checkout($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
	public function my_account($atts, $content = null) {
		extract ( shortcode_atts ( array (
		'el_class' => ''
		), $atts ) );
		$output = '';
		if (! empty ( $el_class ))
			$output .= '<div class="' . $el_class . '">';
		$output .= WC_Shortcodes::my_account($atts);
		if (! empty ( $el_class ))
			$output .= '</div>';
		return $output;
	}
}